/**
 * Created by zhanglianmin on 15-01-26.
 *
 *
 *
 *
 *
 *
 *
 * 类方法：
 * $.activitys.facebook.init(activityUrl, disposeUrl, activityId); //初始化
 * $.activitys.facebook.fbShare(); //分享
 * $.activitys.facebook.listReward(); //返回所有奖励列表
 */

if (typeof jQuery.activitys != 'object') {
    console.log('mast be include jquery.activitys.js');
}

jQuery.activitys.facebook = {
    id:'',
    visitUrl:'',
    disposeUrl:'',
    configs:{},
    appConfig : {
        APP_ID: '',
        TITLE: '',
        CAPTION: '',
        LINK: 'http://www.facebook.com/gm99',
        PICTURE: '',
        DESCRIPTION: '',
        MSG_INVITE_TITLE: '',
        ACTION : {
            'name' : '即用FaceBook玩',
            'link' : ''
        }
    },
    init: function (activityUrl, disposeUrl, activitys) {

        if (typeof activitys != "object" || !activitys.hasOwnProperty('ID')) {
            console.log('activitys data error');
            return;
        }

        $.activitys.forwardUrl = activityUrl;

        this.id = activitys['ID'];
        this.visitUrl = activityUrl;
        this.disposeUrl = disposeUrl;

        //初始化FB
        this._fbInit();

        if (user && user.hasOwnProperty('LOGIN_ACCOUNT')) {
            //this._getAppConfig();
        }

    }
    ,_getAppConfig : function(){
        var that = this;
        var resultStr = $.ajax({
            url: that.disposeUrl,
            type: 'GET',
            data: { action:'getAppConfig', id:that.id},
            async: false
        }).responseText;

        var json;
        if (typeof(JSON) == 'undefined'){
            json = eval("("+resultStr+")");
        }else{
            json = JSON.parse(resultStr);
        }
        if( json.hasOwnProperty('result') && json.result == 1 ){
            that.appConfig = {
                APP_ID: json.data.appId,
                TITLE: json.data.title,
                CAPTION: json.data.caption,
                LINK:  json.data.link,
                PICTURE: json.data.picture,
                DESCRIPTION: json.data.description,
                ACTION : {
                    'name' : '即用FaceBook玩',
                    'link' : json.data.action
                }
            }
        }
    }
    ,_fbInit : function(){
        var that = this;
        //初始化APP信息
        that._getAppConfig();
        window.fbAsyncInit = function () {
            FB.init({
                appId: that.appConfig.APP_ID,
                //status : true, // check login status
                cookie: true, // enable cookies to allow the server to access the session
                xfbml: true,  // parse XFBML
                version: 'v2.6'
            });
        };
        (function(d, s, id){
            var js, fjs = d.getElementsByTagName(s)[0];
            if (d.getElementById(id)) {return;}
            js = d.createElement(s); js.id = id;
            js.src = "//connect.facebook.net/zh_TW/sdk.js";
            fjs.parentNode.insertBefore(js, fjs);
        }(document, 'script', 'facebook-jssdk'));
    }
    ,fbShare : function( callback ){
        var that = this;
        that._check();
        FB.ui({
            name: that.appConfig.TITLE,
            method: 'feed',
            caption: that.appConfig.CAPTION,
            link: that.appConfig.LINK,
            picture: that.appConfig.PICTURE,
            description: that.appConfig.DESCRIPTION,
            actions: that.appConfig.ACTION
        }, function(response) {
            if (response) {
                var userAccount = response.name ? response.name : user.LOGIN_ACCOUNT;
                var resultStr = $.ajax({
                    url: that.disposeUrl,
                    type: 'GET',
                    data: {
                        id : that.id,
                        action:'returnMessage', 
                        params : JSON.stringify( { id : response.post_id || 9999999,  name : userAccount, fb_id : response.post_id || 9999999, fb_name : userAccount } )
                    },
                    async: false
                }).responseText;
                var json;
                if (typeof(JSON) == 'undefined'){
                    json = eval("("+resultStr+")");
                }else{
                    json = JSON.parse(resultStr);
                }
                if( json && json.hasOwnProperty('msg')){
                    alert( json.msg );
                }
                if( callback && typeof callback === 'function' ){
                    callback( json )
                }

            }
        });
    }
    ,listReward : function(){
        var that = this;
        that._check();
        var resultStr = $.ajax({
            url: that.disposeUrl,
            type: 'GET',
            data: { action:'selectCards', id : that.id },
            async: false
        }).responseText;
        var json;
        if (typeof(JSON) == 'undefined'){
            json = eval("("+resultStr+")");
        }else{
            json = JSON.parse(resultStr);
        }
        return json;
    }
    , _check: function () {

        if (this.id <= 0) {
            console.log('Must be the first step in running $.activity.facebook.init(a, b, c).');
        }

    }

};
