/**
 * Created by Royee on 13-12-20.
 *
 * 类属性：
 * $.activitys.forwardUrl //登入注册等外部回跳地址
 *
 * 类方法：
 * $.activitys.login(); //弹出登入框
 * $.activitys.register(); //弹出注册框
 * $.activitys.showDialog(id); //显示弹窗
 * $.activitys.closeDialog(id); //关闭弹出
 *
 */

if (typeof jQuery.activitys != 'object') {
    //console.log('undefind');
    jQuery.extend({
        activitys:{
            forwardUrl:''
            , login: function(forward) {

                forward = forward || encodeURIComponent(this.forwardUrl);
                window.location.href = '//passport.gm99.com/?forward=' + forward;
                //dialog('iframe', '/ajax//passport.gm99.com/?forward=' + forward, 560, 360, 'loginDL');

            }
            , register: function(forward) {

                forward = forward || encodeURIComponent(this.forwardUrl);
                window.location.href = '//passport.gm99.com/?forward=' + forward + '&type=register';
                //dialog('iframe', '/ajax/register/?forward=' + forward, 760, 640, 'regDL');

            }
            , showDialog: function (id) {

                var obj = $('#' + id);
                var popupHeight = obj.height();
                var top = (document.documentElement.clientHeight - popupHeight) / 2 + $(document).scrollTop();
                var left = 0 - Math.ceil(obj.width() / 2);

                $('body').append('<div class="ms-pop-bg" style="width:100%; height:' + document.body.clientHeight +
                    'px; background:#000000; opacity:.6; filter:alpha(opacity=60); position:absolute; top:0; z-index:98;"></div>');
                obj.css({ position: 'absolute', top: top, left: '50%', marginLeft: left, zIndex: 100}).show();

            }
            , closeDialog: function (id) {

                $('.ms-pop-bg').hide().remove();
                $('#' + id).hide();

            }
        }
    });
}