

$( function(){
    /**
     * 加載頁面后焦點開始就在登錄框輸入用戶名處
     * @param url
     * @returns null
     */
    if( $('#uname').length > 0 ){
        $('#uname').focus();
    }

    /**
     * 串接口參數
     * @param url
     * @returns null
     */
    var locationHref = location.href;
    var arrUrl = urlParams( locationHref );
    if( (arrUrl.hasOwnProperty('cid') && arrUrl['cid'] > 0) && (arrUrl.hasOwnProperty('scid') && arrUrl['scid'] != null ) ){
        $('.login_button').each( function(){
            var src = $(this).attr('href');
            if( src.indexOf('javascript') == -1){
                var thisHref = src + '&cid=' + arrUrl['cid'] + '&scid=' + arrUrl['scid'] + '&subid=' + arrUrl['subid'] + '&link_id=' + arrUrl['link_id'];
                $(this).attr({ 'href': thisHref });
            }
        });

        $('.other_login_button').find('li').each( function(){
            var src = $(this).find('a').attr('href');
            if( src.indexOf('javascript') == -1){
                var thisHref = src + '&cid=' + arrUrl['cid'] + '&scid=' + arrUrl['scid'] + '&subid=' + arrUrl['subid'] + '&link_id=' + arrUrl['link_id'];
                $(this).find('a').attr({ 'href': thisHref });
            }
        });

        $('.other_login_button').find('a').each( function(){
            var src = $(this).attr('href');
            if( src.indexOf('javascript') == -1){
                var thisHref = src + '&cid=' + arrUrl['cid'] + '&scid=' + arrUrl['scid'] + '&subid=' + arrUrl['subid'] + '&link_id=' + arrUrl['link_id'];
                $(this).attr({ 'href': thisHref });
            }
        });
    }
    // $('.lgb_2000fun_b').on('click', function (e) {
    //     e.preventDefault();
    //     if (confirm('親愛的主人，2000fun登錄系統正在維護，請聯絡我們的台灣客服專線02-23560356協助處理~')) {
    //         window.location.href = '//service.gm99.com/';
    //     }
    // });
});

function Rsa(){
    if(typeof JSEncrypt === 'undefined') return;
    this.jsencrypt = new JSEncrypt();

    // 设置公钥
    this.jsencrypt.setPublicKey("-----BEGIN PUBLIC KEY-----MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDq04c6My441Gj0UFKgrqUhAUg+kQZeUeWSPlAU9fr4HBPDldAeqzx1UR92KJHuQh/zs1HOamE2dgX9z/2oXcJaqoRIA/FXysx+z2YlJkSk8XQLcQ8EBOkp//MZrixam7lCYpNOjadQBb2Ot0U/Ky+jF2p+Ie8gSZ7/u+Wnr5grywIDAQAB-----END PUBLIC KEY-----");
}

/**
 * rsa加密
 * @param  {string} [str] [待加密字符串]
 * @return {string} [经过rsa加密的字符串]
 */
Rsa.prototype.encode = function(str,confuse){
    var enStr = confuse ? confuse + "|" + str : str;
    return encodeURIComponent(this.jsencrypt.encrypt(enStr)); // rsa+uri编码
}

var rsa = new Rsa();
/**
 * 公共彈窗註冊 帶參數
 * @param url
 * @returns null
 */
function comReg(){
    var regUrl = '//passport.gm99.com/?forward=';
    var locationHref = location.href;
    var arrUrl = urlParams( locationHref );
    var splitLoc = location.href.split('/');
    for( var i = 3; i < splitLoc.length; i++ ){
        if( i == (splitLoc.length - 1) ){
            regUrl += '/' + splitLoc[i].split('?')[0];
        }else{
            regUrl += '/' + splitLoc[i];
        }
    }
    if( (arrUrl.hasOwnProperty('cid') && arrUrl['cid'] > 0) && (arrUrl.hasOwnProperty('scid') && arrUrl['scid'] != null ) ){
        regUrl += '&cid=' +  arrUrl['cid'] + '&scid=' + arrUrl['scid'] + '&subid=' + arrUrl['subid'] + '&link_id=' + arrUrl['link_id'];
    }
    window.location.href = regUrl + '&type=register';
    //dialog('iframe',regUrl , 760, 640, 'regDL');
}

/**
 * 解析url的search
 * @param url
 * @return {Object}
 */
function urlParams(url){
    var args = {};
    // 取查询字符串，以 & 符分开成数组
    var pairs = url.substring(url.indexOf("?")+1,url.length).split("&");
    var pairsLen = pairs.length;
    for(var i= 0; i < pairsLen; i++) {
        // 查找 "name=value" 对，若不成对，则跳出循环继续下一对
        var pos = pairs[i].indexOf('=');
        if (pos == -1) continue;

        // 取参数名，參數值
        var argname = pairs[i].substring(0,pos);
        var value = pairs[i].substring(pos+1);

        // 存成对象的一个属性
        args[argname] = decodeURIComponent(value);
    }

    return args;
}


/**
 * 設置Cookie
 * @param name
 * @param value
 * @param expires
 */
function setCookie(name, value, expires) {
    expires = expires ? expires : 1;

    var expireStr = '';
    if (expires > 0) {
        var days = expires;
        var exp = new Date();
        exp.setTime(exp.getTime() + days * 24 * 60 * 60 * 1000);
        expireStr = ";expires=" + exp.toUTCString();
    } else {
        expireStr = 0;//此 cookie 将在视窗关闭后失效
    }

    document.cookie = name + "=" + escape(value) + expireStr + ";path=/;domain=gm99.com;";
}

/**
 * 獲得Cookie
 * @param name
 * @returns {*}
 */
function getCookie(name) {
    var arr = document.cookie.match(new RegExp("(^| )" + name + "=([^;]*)(;|$)"));
    if (arr != null) return unescape(arr[2]);
    return null;
}

/**
 * 刪除Cookie
 * @param name
 */
function delCookie(name) {
    var exp = new Date();
    exp.setTime(exp.getTime() - 1);
    var cval = getCookie(name);
    if (cval != null) document.cookie = name + "=" + cval + ";expires=" + exp.toUTCString();
}


/* 复制 */
function copyTo(txt) {    
	if(window.clipboardData){    
		window.clipboardData.clearData();    
		window.clipboardData.setData("Text", txt);
		//alert('复制成功！');
		return true;
	}else{
		//alert('自動複製失敗，请手动記錄：' + txt);
		return false;
	}   
}

function copyData(copyText) {
    if (window.clipboardData) 
    {
        window.clipboardData.setData("Text", copyText)
    } 
    else 
    {
        var flashcopier = 'flashcopier';
        if(!document.getElementById(flashcopier)) 
        {
          var divholder = document.createElement('div');
          divholder.id = flashcopier;
          document.body.appendChild(divholder);
        }
        document.getElementById(flashcopier).innerHTML = '';
        var divinfo = '<embed src="/js/_clipboard.swf" FlashVars="clipboard='+encodeURIComponent(copyText)+'" width="0" height="0" type="application/x-shockwave-flash"></embed>';
        document.getElementById(flashcopier).innerHTML = divinfo;
    }
    //alert('copy成功！');
}

	
/*加入收藏夾*/
function AddFavorite(url, title){

    var sURL = url || location.href;
    var sTitle = title || document.title;

    try {
        window.external.AddFavorite(sURL, sTitle);
    } catch (e) {
        try {
            window.sidebar.addPanel(sTitle, sURL, "");
        } catch (e) {
            alert("加入收藏失敗，請使用Ctrl+D進行添加");
        }
    }
}

/********************************
 *
 * 插件调用  dialog(stype, svalue, var3, var4 [,var5])
 *
 * 属性说明
 * stype : 显示类型
 *	    '' - 空，为直接弹出层显示svalue
 *      id - 显示ID为 svalue 的层
 *     img - 显示src地址为 svalue 的图片
 *     url - 显示URL地址为 svalue 的网页内容，由ajax来访问
 *  iframe - 显示src地址为 svlue 的IFRAME
 * svalue : 对应类型 stype 的值
 * var3	  : 在显示前调用的函数名，该函数的返回值需为 true
 * var4   : 在显示后调用的函数名，无返回值 
 * var5   : 参数五，当 type=iframe 时，表示弹窗ID 
 *
 ********************************/
function dialog(stype, svalue, var3, var4, var5) {
	if( undefined==stype || stype=='' ){
		$.dialog({ content: svalue });
	}else{		
		switch( stype ){
			case 'id':
				$.dialog({ id: svalue, content: document.getElementById( svalue ), title:false });
				break;
			case 'iframe':
				if( var3 == null || var3 == '' ) var3 = 680;
				if( var4 == null || var4 == '' ) var3 = 350;
				if( var5 == null || var5 == '' ) return false;
				$.dialog({ id:var5, title:false, fixed:false, 
					content: '<iframe src="' + svalue + '" frameborder="0" width="' + var3 + '" height="' + var4 + 
							'" id="iframeDL" scrolling="no" allowTransparency="true" />' 
				});
				break;
			case 'url':
				var myDialog = $.dialog({title: false, fixed:false});
				$.ajax({
					url: svalue,
					success: function ( data ) {
						myDialog.content( data );// 填充对话框内容
					}
				});
				break;
			case 'img':
				$.dialog({ content: '<img src="' + svalue + '" border="0" />',fixed:false });
				break;
			default:break;
		}
	}
}

function closeDialog(id) {
    art.dialog.list[id].close();
}

/**
 * Tab切换
 *
 * var config = {
 *     tabsName : ,
 *     total : ,
 *     moreUrl : [{ url :  }]
 * }
 */
function changeTabs(currId, config) {
    var tabsName = config.tabsName;
    var total = config.total;
    var moreUrl = config.moreUrl;

    if(tabsName=='' || tabsName==undefined){
        var TabsName = "Tabs";
    }
    for(var i=1;i<=total;i++) {
        $("#"+TabsName+"Li"+i).removeClass('curr');
        $("#"+TabsName+"Div"+i).css('display',"none");
    }
    $("#"+TabsName+"Li"+currId).addClass('curr');
    $("#"+TabsName+"Div"+currId).css('display',"block");

    if (moreUrl) {
        $("#"+TabsName+"More").attr('href', moreUrl[currId-1].url);
    }
}

function gswait(time, sid, name, tips) {
    time = time.replace(/-/g, "/");
    var today = new Date();
    var startTime = new Date(Date.parse(time));

    if (today > startTime && tips) {
        alert(tips);
    } else {
        time = time.substr(5, time.length - 8).replace("/", '月').replace(" ", '日 ');
        tips = tips ? tips : '震撼開啟';
        alert(time + '【S' + sid + '服 ' + name + '】' + tips);
    }

    return false;
}

function gsPlay(game, sid) {
    if (sid > 0) {
        //檢查伺服器是否開放
        $.get('/ajax/ck_server/', { game:game, sid:sid}, function (data) {
            if (!data || data['result'] == 0) {
                alert('該伺服器暫未開放，請耐心等待喲~');
            } else {
                location.href = '/play_games/play/server/' + game + '/id/' + sid;
            }
        }, 'json');
    } else {
        alert('請填寫正確的伺服器');
    }
}

function login( params ){
    var timestamp = new Date().getTime();
    var uname = params['uname'];
    var password = rsa.encode(params['password'],timestamp);
    var forward = params['forward'];
    var remember = params['remember'];
    $.ajax({
        url : '//passport.gm99.com/login/login2',
        type : 'get',
        data:{ 'encrypt':1, 'uname': uname, 'password': password, 'forward': forward, 'remember': remember },
        xhrFields: {
            withCredentials: true
        },
        jsonp: 'callback',
        async : true,
        dataType : 'jsonp',
        success : function(data){
            if( data.hasOwnProperty('result') && data['result'] == 1){
                if( data.hasOwnProperty('bbs_sync') && data['bbs_sync'] ){
                    $('head').append( data['bbs_sync'].replace('\\', '') );
                }
                if (data.hasOwnProperty('forward')) {
                    setTimeout(function(){
                        window.top.location.href = decodeURIComponent( data['forward']) || '/';
                    }, 1000)
                }

            }else{
                alert( data['msg']);
            }

        }
    });

}

// 针对login接口的登录函数（部分官网在调用）
function lessLogin( params ){
    var timestamp = new Date().getTime();
    var uname = params['uname'];
    var password = rsa.encode(params['password'],timestamp);
    var forward = params['forward'];
    var remember = params['remember'];
    $.ajax({
        url : '//passport.gm99.com/login/login',
        type : 'get',
        data:{ 'encrypt':1, 'uname': uname, 'password': password, 'forward': forward, 'remember': remember },
        xhrFields: {
            withCredentials: true
        },
        jsonp: 'callback',
        async : true,
        dataType : 'jsonp',
        success : function(data){
            $('head').append(data);
        }
    });

}

function logout(forward){
    $.ajax({
        url:'//passport.gm99.com/login/logout2?forward=' + forward,
        type : 'get',
        data : { },
        xhrFields: {
            withCredentials: true
        },
        jsonp: 'callback',
        async : true,
        dataType : 'jsonp',
        success : function(data){
            if( data.hasOwnProperty('result') && data['result'] == 1){
                if( data.hasOwnProperty('bbs_sync') && data['bbs_sync'] ){
                    $('head').append( data['bbs_sync'].replace('\\', '') );
                }
                if (data.hasOwnProperty('forward')) {
                    setTimeout(function(){
                        window.top.location.href = decodeURIComponent( data['forward']) || '/';
                    }, 1000)
                }
            }else{
                alert( data['msg']);
            }
        }
    });

}



/*通用选项卡函数，带回调
* API 介绍
* tag : 选项卡选择器， (必须)
* curr ： 当前选中的选项卡样式， (最好填)
* cont ：选项卡内容选择器，数量需和上面的tag个数一致，你懂的。 (必须)
* more ： 更多按钮选择器，(可选)
* ev ：触发事件，默认鼠标划过，(可选)
* before: ev事件未被触发时执行的函数 （可选）
* callbak ：回调函数，可以让你在每一次切换选项卡的时候做些你想做的事， (可选)
*/
function _TAG(conf){
    var tag = conf && conf.tag || '.tag',
        curr = conf && conf.curr || 'curr',
        cont = conf && conf.cont || '.tagCont',
        more = conf && conf.more || '.more',
        ev = conf && conf.ev || 'mouseover',
        time = conf && conf.time || 500,
        before = conf && conf.before,
        callback = conf && conf.callback;
    var $tag = $(tag),$cont = $(cont),$more = conf.more ? $(more) : $(document);
    $tag.eq(0).addClass(curr);
    $cont.eq(0).stop().fadeIn(200);
    before && before();
    $tag.on(ev,function(){
        var that = $(this);
        var i = that.index(tag);
        that.addClass(curr).siblings(tag).removeClass(curr);
        $cont.fadeOut(time).eq(i).fadeIn(time);
        if (conf.more){
            $more.attr('href',that.attr('url'));
        };
        callback && callback(that,i);
    });
}


/*跳錨點*/
function scrollAnchor( anchorName ){
    var $body = (window.opera) ? (document.compatMode == "CSS1Compat" ? $('html') : $('body')) : $('html,body');
    if( anchorName ){
//        var $this = $('*[name="' + anchorName + '"]');
        var $this = $('#'+anchorName);
        var $this_top = $this.offset().top;
        $body.animate({ scrollTop: $this_top}, 600);
    }else{
        $body.animate({ scrollTop: 0}, 600);
    }

}


/*My VIP
* 返回三个属性level、growth、next_vip_need
*level为等级
* growth为成长值
* next_vip_need为下一等级需要成长值
*/
function VIP(){

    var _Vip;
    var str = $.ajax({
        type:'get',
        url:'//www.gm99.com/vip/my',
        dataType:'json',
        async:false
    }).responseText;
    if( str != '' ){
        if( typeof (JSON) != 'undefined' ){
            _Vip = JSON.parse( str );
        }else{
            _Vip = eval( '('+ str +')' );
        }
        return _Vip;
    }else{
        return false;
    }

}