var commonEvent = { };

commonEvent.opts = {
    dialogIndex : 98,
    autoDialog : { },
    forward : '/'
};

commonEvent.showDialog = function( id ){
    var that = this;
    var obj = $('#' + id);
    var popupHeight = obj.height();
    var top = (document.documentElement.clientHeight - popupHeight) / 2 + $(document).scrollTop();
    var left = 0 - Math.ceil(obj.width() / 2);

    $('body').append('<div class="ms-pop-bg" style="width:100%; height:' + $(document).height() +
        'px; background:#000000; opacity:.6; filter:alpha(opacity=60); position:absolute; top:0; z-index:' + that.opts.dialogIndex + ';"></div>');
    that.opts.dialogIndex = that.opts.dialogIndex + 1;
    obj.css({ position: 'absolute', top: top, left: '50%', marginLeft: left, zIndex: that.opts.dialogIndex }).show();
    that.opts.dialogIndex = that.opts.dialogIndex + 1;
    that.opts.autoDialog[ id ] = setInterval( function(){
        top = (document.documentElement.clientHeight - popupHeight) / 2 + $(document).scrollTop();
        obj.css({ top : top });
    }, 50);
};

commonEvent.closeDialog = function( id ){
    var that = this;
    clearInterval( that.opts.autoDialog[id] );
    $('.ms-pop-bg').hide().remove();
    $('#' + id).hide();
};

commonEvent.checkLogin = function(){
    var that = this;
    if( !user ){
        that.login();
        //dialog('iframe','/ajax/login/?forward=' + that.opts.forward, 560, 360, 'loginDL');
        return false;
    }
};

commonEvent.login = function(){
    var that = this;
    window.location.href = '//passport.gm99.com/?forward='+that.opts.forward;
};

//活動FACEBOOK
commonEvent.App = { };
commonEvent.App.opts = {
    APP_ID : '',
    link: '',
    picture:'',
    title : '',
    caption : '',
    actions : { 'name': '立即用Facebook玩', 'link':  this.link },
    description: '',
    ref : 'none'
};

commonEvent.App.init = function( opstions, callback ){
    var that = this;
    that.opts = $.extend( { }, that.opts, opstions );
    window.fbAsyncInit = function() {
        FB.init({
            appId      :  that.opts.APP_ID,
            xfbml      : true,
            version    : 'v2.6'
        });
        callback && typeof callback == 'function' && callback(FB);
    };

    (function(d, s, id){
        var js, fjs = d.getElementsByTagName(s)[0];
        if (d.getElementById(id)) {return;}
        js = d.createElement(s); js.id = id;
        js.src = "//connect.facebook.net/zh_TW/sdk.js";
        fjs.parentNode.insertBefore(js, fjs);
    }(document, 'script', 'facebook-jssdk'));

};

commonEvent.App.share = function( success, fail, callback ){
    var that = this;
    // call the API
    FB.ui({
        method: 'feed',
        link: that.opts.link,
        picture: that.opts.picture,
        name: that.opts.title,
        caption: that.opts.caption,
        actions: that.opts.action,
        description: that.opts.description,
        ref: that.opts.ref
    }, function(response){
        // 記錄用戶的PO文内容
        if( response ) {
            //分享成功執行
            success && typeof success == 'function' && success(response);
        }else{
            //分享失敗執行
            fail && typeof fail == 'function' && fail(response);
        }
        callback && typeof callback == 'function' && callback(response);
    });
};

commonEvent.App.getLoginStatus = function(){
    var that = this;
    FB.getLoginStatus(function(response) {
        if (response.status === 'connected') {
            //console.log('Logged in.');
        }
        else {
            that.login();
        }
    });
};

commonEvent.App.login = function( success, fail ){
    FB.login(function(response) {
        if (response.authResponse) {
            //console.log('Welcome!  Fetching your information.... ');
            FB.api('/me', function(response) {
                success && typeof success == 'function' && success(response);
            });
        } else {
            fail && typeof fail == 'function' && fail(response);
        }
    });
};

// 判斷用戶是否對粉絲頁點贊，若點贊則領取獎勵 //
// 步驟1：檢查用戶是否登錄
commonEvent.App.isLikePage = function(callback) {
    FB.login(function(response) {
        console.log( response );
        if (response.authResponse) {
            commonEvent.App._isGrantPermission(callback);
        } else {
            console.log('用戶取消登錄或未認證');
        }
    }, {
        scope: 'user_likes',
        return_scopes: true
    });
};
// 步驟2：檢查用戶是否授權
commonEvent.App._isGrantPermission = function(callback) {
    FB.api(
        "/me/permissions",
        function(response) {
            console.log( response );
            if (response && !response.error) {
                var permissionArr = response.data;
                var permissionLen = permissionArr.length;

                for (var i = 0; i < permissionLen; i++) {

                    if (permissionArr[i].permission == "user_likes") {
                        // console.log("該用戶擁有user_likes權限");
                        commonEvent.App._checkLike(callback);
                        break;
                    } else{
                        // console.log("該用戶沒有user_likes權限");
                    }
                }

            }
        }
    );
};
// 步驟3：檢查是否對頁面點贊
commonEvent.App._checkLike = function(callback) {

    FB.api("me/likes/" + commonEvent.App.opts.APP_ID, function(response) {
        // 若點贊則發放獎勵
        callback && typeof callback == 'function' && callback(response);
    });
};